//////////////////////////////////////////////////////////////////////////////////////////
////                                                                                  ////
////                                 Global Variables                                 ////
////                                                                                  ////
//////////////////////////////////////////////////////////////////////////////////////////
extern int MagicNumber=10001;
extern double baseLotSize=0.01;
extern int lotSizeMultiplier=1;
extern int Step=10;
extern double TargetProfit;

int Slippage=3;
double MyPoint=Point;

///////////////////////////////////////////////////////////////////////////////////////////
////                                                                                   ////
////                                   Main Function                                   ////
////                                                                                   ////
///////////////////////////////////////////////////////////////////////////////////////////
int start()
{ 
  if(Digits==3 || Digits==5)
  MyPoint=Point*10;
  double accountBalance=AccountBalance();
  
  
  if(NormalizeDouble(accountBalance, 2) >= NormalizeDouble(TargetProfit, 2))
  {
    Comment("Profit Target Was Reached!\n", "TargetProfit Must only be Greater than Account Balance.");
  }
  
  if(
      (NormalizeDouble(accountBalance, 2) < NormalizeDouble(TargetProfit, 2))
      ||
      (
        (NormalizeDouble(accountBalance, 2) >= NormalizeDouble(TargetProfit, 2))&&
        (OrdersTotal()>0)
      )
    )
  {
    if(OrdersTotal()==0)
    {
      if(MathRand()%2==0)
      openBuy();
      else
      openSell();
    }
    
    if(OrdersTotal()>0)
    { 
      //for cleanup purposes
      if(activeOrdersTotal()==0 && pendingOrdersTotal()>0)
      {
        closeAllPendingOrders();
      }    
      
      //to add more orders if needed
      double HighGreenZoneProfit=NormalizeDouble(HighGreenZoneProfit(), 2);
      double HighGreenZoneTargetProfit=NormalizeDouble(HighGreenZoneTargetProfit(), 2);
      //double HighGreenZoneTargetProfit=NormalizeDouble(AccountBalance()/100, 2);
  
      double smallestPendingBuyLotSize=NormalizeDouble(smallestPendingBuyLotSize(), 2);
      double getLotSize=NormalizeDouble(getLotSize(), 2);
      
      if(
          (
            (HighGreenZoneProfit<HighGreenZoneTargetProfit)&&
            (pendingBuyOrdersTotal()>0)&&
            (smallestPendingBuyLotSize!=getLotSize)
          )
          ||
          (
            (HighGreenZoneProfit>HighGreenZoneTargetProfit)&&
            (pendingBuyOrdersTotal()>0)&&
            (smallestPendingBuyLotSize!=getLotSize)
          )
        )
      {
        Print("HighGreenZone: ", smallestPendingBuyLotSize, " != ", getLotSize);
        closeAllPendingBuyOrders();
      }
      
      if(HighGreenZoneProfit<HighGreenZoneTargetProfit)
      { 
        if(
            (activeOrdersTotal()>0)&&
            (pendingBuyOrdersTotal()==0)
          )
        {
          openBuyStop();
        }
        
        if(
            (activeOrdersTotal()>0)&&
            (pendingBuyOrdersTotal()>0)&&
            (smallestPendingBuyLotSize==getLotSize)
          )
        {
          openNextBuyStop();
        }
      }
      
      double LowGreenZoneProfit=NormalizeDouble(LowGreenZoneProfit(), 2);
      double LowGreenZoneTargetProfit=NormalizeDouble(LowGreenZoneTargetProfit(), 2);
      //double LowGreenZoneTargetProfit=NormalizeDouble(AccountBalance()/100, 2);
      
      double smallestPendingSellLotSize=NormalizeDouble(smallestPendingSellLotSize(), 2);
      double getLotSize_=NormalizeDouble(getLotSize(), 2);
      
      if(
          (
            (LowGreenZoneProfit<LowGreenZoneTargetProfit)&&
            (pendingSellOrdersTotal()>0)&&
            (smallestPendingSellLotSize!=getLotSize_)
          )
          ||
          (
            (LowGreenZoneProfit>=LowGreenZoneTargetProfit)&&
            (pendingSellOrdersTotal()>0)&&
            (smallestPendingSellLotSize!=getLotSize_)
          )
        )
      {
        Print("LowGreenZone: ", smallestPendingSellLotSize, " != ", getLotSize_);
        closeAllPendingSellOrders();
      }
      
      if(LowGreenZoneProfit<LowGreenZoneTargetProfit)
      { 
        if(
            (activeOrdersTotal()>0)&&
            (pendingSellOrdersTotal()==0)
          )
        {
          openSellStop();
        }
        
        if(
            (activeOrdersTotal()>0)&&
            (pendingSellOrdersTotal()>0)&&
            (smallestPendingSellLotSize==getLotSize_)
          )
        {
          openNextSellStop();
        }
      }
      
      //to set stops
      if(
          (
            (HighGreenZoneProfit>=HighGreenZoneTargetProfit)&&
            (pendingBuyOrdersTotal()>0)&&
            (smallestPendingBuyLotSize==getLotSize)
          )
          ||
          (
            (HighGreenZoneProfit>=HighGreenZoneTargetProfit)&&
            (pendingBuyOrdersTotal()==0)
          )
        )
      {
        setHighGreenZoneStopLimit();
      }
      if(
          (
            (LowGreenZoneProfit>=LowGreenZoneTargetProfit)&&
            (pendingSellOrdersTotal()>0)&&
            (smallestPendingSellLotSize==getLotSize_)
          )
          ||
          (
            (LowGreenZoneProfit>=LowGreenZoneTargetProfit)&&
            (pendingSellOrdersTotal()==0)
          )
        )
      {
        setLowGreenZoneStopLimit();
      }
    } 
  }
  return true;
}

//////////////////////////////////////////////////////////////////////////////////////////
////                                                                                  ////
////                                 Custom Functions                                 ////
////                                                                                  ////
//////////////////////////////////////////////////////////////////////////////////////////
double HighestOrder()
{
  double maxOPP;
  if(OrdersTotal()>0)
  {
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      maxOPP=OrderOpenPrice();
      for(int i=OrdersTotal()-1; i>=0; i--)
      {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        {
          if(OrderType()==OP_BUY || OrderType()==OP_SELL || OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP)
          {
            maxOPP=MathMax(maxOPP, OrderOpenPrice());
          }
        }
      }
    }
  }
  return maxOPP;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double LowestOrder()
{
  double minOPP;
  if(OrdersTotal()>0)
  {
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      minOPP=OrderOpenPrice();
      for(int i=OrdersTotal()-1; i>=0; i--)
      {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        {
          if(OrderType()==OP_BUY || OrderType()==OP_SELL || OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP)
          {
            minOPP=MathMin(minOPP, OrderOpenPrice());
          }
        }
      }
    }
  }
  return minOPP;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double HighestActiveOrder()
{
  double maxOPP;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      double orderOpenPrice=OrderOpenPrice();
      int orderType=OrderType();
      
      if(orderType==OP_BUY || orderType==OP_SELL)
      {
        maxOPP=orderOpenPrice;
      }
    }
  }
  
  for(int j=OrdersTotal()-1; j>=0; j--)
  {
    if(OrderSelect(j, SELECT_BY_POS, MODE_TRADES))
    {
      double orderOpenPricej=OrderOpenPrice();
      int orderTypej=OrderType();
      if(orderTypej==OP_BUY || orderTypej==OP_SELL)
      {
        maxOPP=MathMax(maxOPP, orderOpenPricej);
      }
    }
  }
  return maxOPP;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double LowestActiveOrder()
{
  double minOPP;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      double orderOpenPrice=OrderOpenPrice();
      int orderType=OrderType();
      
      if(orderType==OP_BUY || orderType==OP_SELL)
      {
        minOPP=orderOpenPrice;
      }
    }
  }
  
  for(int j=OrdersTotal()-1; j>=0; j--)
  {
    if(OrderSelect(j, SELECT_BY_POS, MODE_TRADES))
    {
      double orderOpenPricej=OrderOpenPrice();
      int orderTypej=OrderType();
      if(orderTypej==OP_BUY || orderTypej==OP_SELL)
      {
        minOPP=MathMin(minOPP, orderOpenPricej);
      }
    }
  }
  return minOPP;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double HighGreenZoneProfit()
{
  double Total=0;
  double Profit=0;
  int orderType;
  double orderLot=0;
  double orderOP=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderType=OrderType();
      orderLot=OrderLots();
      orderOP=OrderOpenPrice();
      
      if(orderOP>=LowestActiveOrder() && orderOP<=HighestOrder())
      {
        if(orderType==OP_BUY || orderType==OP_BUYSTOP)
        {
          Profit=(((HighestOrder()+Step*MyPoint)-orderOP)*(10000))*(orderLot*10);
        }
        if(orderType==OP_SELL || orderType==OP_SELLSTOP)
        {
          Profit=((orderOP-((HighestOrder()+Step*MyPoint)+MathAbs(Ask-Bid)))*(10000))*(orderLot*10);
        }
        Total=Total+Profit;
        continue;
      }
    }
  }
  return Total;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double LowGreenZoneProfit()
{
  double Total=0;
  double Profit=0;
  int orderType;
  double orderLot=0;
  double orderOP=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderType=OrderType();
      orderLot=OrderLots();
      orderOP=OrderOpenPrice();
      
      if(orderOP<=HighestActiveOrder() && orderOP>=LowestOrder())
      {
        if(orderType==OP_BUY || orderType==OP_BUYSTOP)
        {
          Profit=((((LowestOrder()-Step*MyPoint)-MathAbs(Ask-Bid))-orderOP)*(10000))*(orderLot*10);
        }
        if(orderType==OP_SELL || orderType==OP_SELLSTOP)
        {
          Profit=((orderOP-(LowestOrder()-Step*MyPoint))*(10000))*(orderLot*10);
        }
        Total=Total+Profit;
        continue;
      }
    }
  }
  return Total;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int closeAllPendingOrders()
{
  int pendingOrdersTotal=0;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      int orderType=OrderType();
      int orderTicket=OrderTicket();
      if(orderType==OP_BUYSTOP || orderType==OP_SELLSTOP)
      {
        if(OrderDelete(orderTicket, Red))
        continue;
      }
    }
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int closeAllPendingBuyOrders()
{ 
  int orderTicket;
  double orderOpenPrice;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {    
      orderTicket=OrderTicket();
      orderOpenPrice=OrderOpenPrice();
      
      if(orderOpenPrice>HighestActiveOrder())
      {
        if(OrderDelete(orderTicket, Red))
        continue;
      }
    }
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int closeAllPendingSellOrders()
{
  int orderTicket;
  double orderOpenPrice;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderTicket=OrderTicket();
      orderOpenPrice=OrderOpenPrice();
      
      if(orderOpenPrice<LowestActiveOrder())
      {
        if(OrderDelete(orderTicket, Red))
        continue;
      }
    }
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double HighGreenZoneTargetProfit()
{
  double totalOrderLots=0;
  double orderOpenPrice;
  double orderLotSize;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderLotSize=OrderLots();
      orderOpenPrice=OrderOpenPrice();
      
      if(orderOpenPrice>=LowestActiveOrder() && orderOpenPrice<=HighestOrder())
      {
        totalOrderLots=totalOrderLots+orderLotSize;
      }
    }
  }
  return totalOrderLots*100;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double LowGreenZoneTargetProfit()
{
  double totalOrderLots=0;
  double orderOpenPrice;
  double orderLotSize;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderLotSize=OrderLots();
      orderOpenPrice=OrderOpenPrice();
      
      if(orderOpenPrice<=HighestActiveOrder() && orderOpenPrice>=LowestOrder())
      {
        totalOrderLots=totalOrderLots+orderLotSize;
      }
    }
  }
  return totalOrderLots*100;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double getLotSize()
{
  //double lotSize = maxActiveOrderLotSize()+(baseLotSize*lotSizeMultiplier);
  //double lotSize = baseLotSize;
  
  int simpleLot=AccountBalance()/1000;
  double transactedLot=simpleLot;
  double lotSize = NormalizeDouble(transactedLot/100, 2);
  
  double min_lot = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
  double max_lot = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);

  if(lotSize < min_lot)
  lotSize = min_lot;

  if(lotSize > max_lot)
  lotSize = max_lot;

  return (lotSize);
}

//----------------------------------------------------------------------------------------------------------------------------------------
double getNextPendingSellLotSize()
{
  //double lotSize = maxPendingSellOrderLotSize()+(baseLotSize*lotSizeMultiplier);
  //double lotSize = baseLotSize;
  
  int simpleLot=AccountBalance()/1000;
  double transactedLot=simpleLot;
  double lotSize = NormalizeDouble(transactedLot/100, 2);
  
  double min_lot = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
  double max_lot = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);

  if(lotSize < min_lot)
  lotSize = min_lot;

  if(lotSize > max_lot)
  lotSize = max_lot;

  return (lotSize);
}

//----------------------------------------------------------------------------------------------------------------------------------------
double getNextPendingBuyLotSize()
{
  //double lotSize = maxPendingBuyOrderLotSize()+(baseLotSize*lotSizeMultiplier);
  //double lotSize = baseLotSize;
  
  int simpleLot=AccountBalance()/1000;
  double transactedLot=simpleLot;
  double lotSize = NormalizeDouble(transactedLot/100, 2);
  
  double min_lot = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
  double max_lot = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);

  if(lotSize < min_lot)
  lotSize = min_lot;

  if(lotSize > max_lot)
  lotSize = max_lot;

  return (lotSize);
}

//----------------------------------------------------------------------------------------------------------------------------------------
double maxActiveOrderLotSize()
{
  double maxLot=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUY || OrderType()==OP_SELL)
      {
        maxLot=MathMax(maxLot, OrderLots());
      }
    }
  }
  return maxLot;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double maxPendingBuyOrderLotSize()
{
  double maxLot=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUYSTOP)
      {
        maxLot=MathMax(maxLot, OrderLots());
      }
    }
  }
  return maxLot;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double maxPendingSellOrderLotSize()
{
  double maxLot=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_SELLSTOP)
      {
        maxLot=MathMax(maxLot, OrderLots());
      }
    }
  }
  return maxLot;
}
//----------------------------------------------------------------------------------------------------------------------------------------
int openSell()
{
  if(OrderSend(Symbol(),OP_SELL,getLotSize(),Bid,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Red))
  return true;
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int openBuy()
{
  if(OrderSend(Symbol(),OP_BUY,getLotSize(),Ask,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Blue))
  return true;
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int openSellStop()
{
  double entryLevel=LowestOrder()-Step*MyPoint;
  
  if(Bid>entryLevel)
  {
    if(OrderSend(Symbol(),OP_SELLSTOP,getLotSize(),entryLevel,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Red))
    return true;
  }
  if(Bid<=entryLevel)
  {
    if(OrderSend(Symbol(),OP_SELL,getLotSize(),Bid,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Red))
    return true;
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int openBuyStop()
{
  double entryLevel=HighestOrder()+Step*MyPoint;
  
  if(Ask<=entryLevel)
  {
    if(OrderSend(Symbol(),OP_BUYSTOP,getLotSize(),entryLevel,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Blue))
    return true;
  }
  if(Ask>entryLevel)
  {
    if(OrderSend(Symbol(),OP_BUY,getLotSize(), Ask,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Blue))
    return true;
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int openNextSellStop()
{
  double entryLevel=LowestOrder()-Step*MyPoint;
  
  if(Bid>entryLevel)
  {
    if(OrderSend(Symbol(),OP_SELLSTOP,getNextPendingSellLotSize(),entryLevel,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Red))
    return true;
  }
  if(Bid<=entryLevel)
  {
    if(OrderSend(Symbol(),OP_SELL,getNextPendingSellLotSize(),Bid,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Red))
    return true;
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int openNextBuyStop()
{
  double entryLevel=HighestOrder()+Step*MyPoint;
  
  if(Ask<=entryLevel)
  {
    if(OrderSend(Symbol(),OP_BUYSTOP,getNextPendingBuyLotSize(),entryLevel,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Blue))
    return true;
  }
  if(Ask>entryLevel)
  {
    if(OrderSend(Symbol(),OP_BUY,getNextPendingBuyLotSize(), Ask,Slippage,0,0,"ExtremeHedge",MagicNumber,0,Blue))
    return true;
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int activeOrdersTotal()
{
  int activeOrdersTotal=0;
  int orderType;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderType=OrderType();
      if(orderType==OP_BUY || orderType==OP_SELL)
      {
        activeOrdersTotal++;
      }
    }
  }
  
  return activeOrdersTotal;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int pendingOrdersTotal()
{
  int pendingOrdersTotal=0;
  int orderType;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderType=OrderType();
      if(orderType==OP_BUYSTOP || orderType==OP_SELLSTOP)
      {
        pendingOrdersTotal++;
      }
    }
  }
  
  return pendingOrdersTotal;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int pendingBuyOrdersTotal()
{
  int pendingBuyOrdersTotal=0;
  int orderType;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderType=OrderType();
      if(orderType==OP_BUYSTOP)
      {
        pendingBuyOrdersTotal++;
      }
    }
  }
  
  return pendingBuyOrdersTotal;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int pendingSellOrdersTotal()
{
  int pendingSellOrdersTotal=0;
  int orderType;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderType=OrderType();
      if(orderType==OP_SELLSTOP)
      {
        pendingSellOrdersTotal++;
      }
    }
  }
  
  return pendingSellOrdersTotal;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double smallestPendingBuyLotSize()
{
  double smallestPendingBuyLotSize;
  int orderType;
  double orderLots;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderType=OrderType();
      orderLots=OrderLots();
      if(orderType==OP_BUYSTOP)
      {
        smallestPendingBuyLotSize=orderLots;
      }
    }
  }
  
  for(int j=OrdersTotal()-1; j>=0; j--)
  {
    if(OrderSelect(j, SELECT_BY_POS, MODE_TRADES))
    {
      orderType=OrderType();
      orderLots=OrderLots();
      if(orderType==OP_BUYSTOP)
      {
        smallestPendingBuyLotSize=MathMin(smallestPendingBuyLotSize, orderLots);
      }
    }
  }
  
  return smallestPendingBuyLotSize;
}
//----------------------------------------------------------------------------------------------------------------------------------------
double smallestPendingSellLotSize()
{
  double smallestPendingSellLotSize;
  int orderType;
  double orderLots;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderType=OrderType();
      orderLots=OrderLots();
      if(orderType==OP_SELLSTOP)
      {
        smallestPendingSellLotSize=orderLots;
      }
    }
  }
  
  for(int j=OrdersTotal()-1; j>=0; j--)
  {
    if(OrderSelect(j, SELECT_BY_POS, MODE_TRADES))
    {
      orderType=OrderType();
      orderLots=OrderLots();
      if(orderType==OP_SELLSTOP)
      {
        smallestPendingSellLotSize=MathMin(smallestPendingSellLotSize, orderLots);
      }
    }
  }
  
  return smallestPendingSellLotSize;
}
//----------------------------------------------------------------------------------------------------------------------------------------
int setHighGreenZoneStopLimit()
{
  double orderOpenPrice;
  double orderStopLoss;
  double orderTakeProfit;
  int orderType;
  int orderTicket;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderOpenPrice=OrderOpenPrice();
      orderStopLoss=OrderStopLoss();
      orderTakeProfit=OrderTakeProfit();
      orderType=OrderType();
      orderTicket=OrderTicket();
      
      double HighGreenZoneLevel=HighestOrder()+(Step*MyPoint);
      
      if(Ask<HighGreenZoneLevel)
      {
        if(orderOpenPrice>=LowestActiveOrder() && orderOpenPrice<=HighestOrder())
        {
          if(orderType==OP_BUY || orderType==OP_BUYSTOP)
          {
            if(orderTakeProfit!=(HighestOrder()+Step*MyPoint))
            {
              if(OrderModify(orderTicket, orderOpenPrice, orderStopLoss, (HighestOrder()+Step*MyPoint), 0, Green))
              continue;
            }
          }
          if(orderType==OP_SELL || orderType==OP_SELLSTOP)
          {
            if(orderStopLoss!=(HighestOrder()+Step*MyPoint+MathAbs(Ask-Bid)))
            {
              if(OrderModify(orderTicket, orderOpenPrice, (HighestOrder()+Step*MyPoint+MathAbs(Ask-Bid)), orderTakeProfit, 0, Green))
              continue;
            }
          }
        }
      }
      if(Bid>HighGreenZoneLevel+(Step*MyPoint))
      {
        if(orderOpenPrice>=LowestActiveOrder() && orderOpenPrice<=HighestOrder())
        {
          if(orderType==OP_BUY || orderType==OP_BUYSTOP)
          {
            if(Bid-orderOpenPrice>Step*MyPoint)
            {
              if((orderStopLoss<Bid-Step*MyPoint) || (orderStopLoss == 0))
              {
                if(OrderModify(orderTicket,orderOpenPrice, Bid-Step*MyPoint, orderTakeProfit, 0, Green))
                continue;
              }
            }
          }
          if(orderType==OP_SELL || orderType==OP_SELLSTOP)
          {
            if((Ask-orderOpenPrice)>(Step*MyPoint))
            {
              if((orderTakeProfit<(Ask-Step*MyPoint)) || (orderTakeProfit==0))
              {
                if(OrderModify(orderTicket,orderOpenPrice, orderStopLoss, Ask-Step*MyPoint, 0, Red))
                continue;
              }
            }
          }
        }
      }
    }
  }  
  return true;
}
//----------------------------------------------------------------------------------------------------------------------------------------
int setLowGreenZoneStopLimit()
{
  double orderOpenPrice;
  double orderStopLoss;
  double orderTakeProfit;
  int orderType;
  int orderTicket;
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      orderOpenPrice=OrderOpenPrice();
      orderStopLoss=OrderStopLoss();
      orderTakeProfit=OrderTakeProfit();
      orderType=OrderType();
      orderTicket=OrderTicket();
      
      double LowGreenZoneLevel=LowestOrder()-(Step*MyPoint);
      
      if(Bid>LowGreenZoneLevel)
      {
        if(orderOpenPrice<=HighestActiveOrder() && orderOpenPrice>=LowestOrder())
        {
          if(orderType==OP_BUY || orderType==OP_BUYSTOP)
          {
            if(orderStopLoss!=(LowestOrder()-Step*MyPoint-MathAbs(Ask-Bid)))
            {
              if(OrderModify(orderTicket, orderOpenPrice, (LowestOrder()-Step*MyPoint-MathAbs(Ask-Bid)), orderTakeProfit, 0, Green))
              continue;
            }
          }
          if(orderType==OP_SELL || orderType==OP_SELLSTOP)
          {
            if(orderTakeProfit!=(LowestOrder()-Step*MyPoint))
            {
              if(OrderModify(orderTicket, orderOpenPrice, orderStopLoss, (LowestOrder()-Step*MyPoint), 0, Green))
              continue;
            }
          }
        }
      }
      if(Ask<LowGreenZoneLevel-(Step*MyPoint))
      {
        if(orderOpenPrice<=HighestActiveOrder() && orderOpenPrice>=LowestOrder())
        {
          if(orderType==OP_BUY || orderType==OP_BUYSTOP)
          {
            if(orderOpenPrice-Bid>Step*MyPoint)
            {
              if((orderTakeProfit>Bid+Step*MyPoint)||(orderTakeProfit==0))
              {
                if(OrderModify(orderTicket, orderOpenPrice, orderStopLoss, Bid+Step*MyPoint, 0, Green))
                continue;
              }
            }
          }
          if(orderType==OP_SELL || orderType==OP_SELLSTOP)
          {
            if(orderOpenPrice-Ask>Step*MyPoint)
            {
              if((orderStopLoss>(Ask+Step*MyPoint)) || (orderStopLoss==0))
              {
                if(OrderModify(orderTicket,orderOpenPrice,Ask+Step*MyPoint, orderTakeProfit, 0, Red))
                continue;
              }
            }
          }
        }
      }
    }
  }
  
  return true;
}
//----------------------------------------------------------------------------------------------------------------------------------------